/* AbstractSearchRow.c generated by valac 0.42.2, the Vala compiler
 * generated from AbstractSearchRow.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*               2018 elementary LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* Represents a row-type.*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gobject/gvaluecollector.h>


#define TYPE_SEARCH_ROW (search_row_get_type ())
#define SEARCH_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEARCH_ROW, SearchRow))
#define SEARCH_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEARCH_ROW, SearchRowClass))
#define IS_SEARCH_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEARCH_ROW))
#define IS_SEARCH_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEARCH_ROW))
#define SEARCH_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEARCH_ROW, SearchRowClass))

typedef struct _SearchRow SearchRow;
typedef struct _SearchRowClass SearchRowClass;
typedef struct _SearchRowPrivate SearchRowPrivate;

#define TYPE_SEARCH_CONDITION (search_condition_get_type ())
#define SEARCH_CONDITION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEARCH_CONDITION, SearchCondition))
#define SEARCH_CONDITION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEARCH_CONDITION, SearchConditionClass))
#define IS_SEARCH_CONDITION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEARCH_CONDITION))
#define IS_SEARCH_CONDITION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEARCH_CONDITION))
#define SEARCH_CONDITION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEARCH_CONDITION, SearchConditionClass))

typedef struct _SearchCondition SearchCondition;
typedef struct _SearchConditionClass SearchConditionClass;
typedef struct _ParamSpecSearchRow ParamSpecSearchRow;

struct _SearchRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SearchRowPrivate * priv;
};

struct _SearchRowClass {
	GTypeClass parent_class;
	void (*finalize) (SearchRow *self);
	GtkWidget* (*get_widget) (SearchRow* self);
	SearchCondition* (*get_search_condition) (SearchRow* self);
	void (*populate) (SearchRow* self, SearchCondition* sc);
	gboolean (*is_complete) (SearchRow* self);
};

struct _ParamSpecSearchRow {
	GParamSpec parent_instance;
};


static gpointer search_row_parent_class = NULL;

gpointer search_row_ref (gpointer instance);
void search_row_unref (gpointer instance);
GParamSpec* param_spec_search_row (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_search_row (GValue* value,
                           gpointer v_object);
void value_take_search_row (GValue* value,
                            gpointer v_object);
gpointer value_get_search_row (const GValue* value);
GType search_row_get_type (void) G_GNUC_CONST;
gpointer search_condition_ref (gpointer instance);
void search_condition_unref (gpointer instance);
GParamSpec* param_spec_search_condition (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
void value_set_search_condition (GValue* value,
                                 gpointer v_object);
void value_take_search_condition (GValue* value,
                                  gpointer v_object);
gpointer value_get_search_condition (const GValue* value);
GType search_condition_get_type (void) G_GNUC_CONST;
GtkWidget* search_row_get_widget (SearchRow* self);
static GtkWidget* search_row_real_get_widget (SearchRow* self);
SearchCondition* search_row_get_search_condition (SearchRow* self);
static SearchCondition* search_row_real_get_search_condition (SearchRow* self);
void search_row_populate (SearchRow* self,
                          SearchCondition* sc);
static void search_row_real_populate (SearchRow* self,
                               SearchCondition* sc);
gboolean search_row_is_complete (SearchRow* self);
static gboolean search_row_real_is_complete (SearchRow* self);
SearchRow* search_row_construct (GType object_type);
static void search_row_finalize (SearchRow * obj);


static GtkWidget*
search_row_real_get_widget (SearchRow* self)
{
#line 24 "../src/Widgets/AbstractSearchRow.vala"
	g_critical ("Type `%s' does not implement abstract method `search_row_get_widget'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 24 "../src/Widgets/AbstractSearchRow.vala"
	return NULL;
#line 124 "AbstractSearchRow.c"
}


GtkWidget*
search_row_get_widget (SearchRow* self)
{
#line 24 "../src/Widgets/AbstractSearchRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Widgets/AbstractSearchRow.vala"
	return SEARCH_ROW_GET_CLASS (self)->get_widget (self);
#line 135 "AbstractSearchRow.c"
}


static SearchCondition*
search_row_real_get_search_condition (SearchRow* self)
{
#line 27 "../src/Widgets/AbstractSearchRow.vala"
	g_critical ("Type `%s' does not implement abstract method `search_row_get_search_condition'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 27 "../src/Widgets/AbstractSearchRow.vala"
	return NULL;
#line 146 "AbstractSearchRow.c"
}


SearchCondition*
search_row_get_search_condition (SearchRow* self)
{
#line 27 "../src/Widgets/AbstractSearchRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/Widgets/AbstractSearchRow.vala"
	return SEARCH_ROW_GET_CLASS (self)->get_search_condition (self);
#line 157 "AbstractSearchRow.c"
}


static void
search_row_real_populate (SearchRow* self,
                          SearchCondition* sc)
{
#line 30 "../src/Widgets/AbstractSearchRow.vala"
	g_critical ("Type `%s' does not implement abstract method `search_row_populate'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 30 "../src/Widgets/AbstractSearchRow.vala"
	return;
#line 169 "AbstractSearchRow.c"
}


void
search_row_populate (SearchRow* self,
                     SearchCondition* sc)
{
#line 30 "../src/Widgets/AbstractSearchRow.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Widgets/AbstractSearchRow.vala"
	SEARCH_ROW_GET_CLASS (self)->populate (self, sc);
#line 181 "AbstractSearchRow.c"
}


static gboolean
search_row_real_is_complete (SearchRow* self)
{
	gboolean _tmp0_ = FALSE;
#line 33 "../src/Widgets/AbstractSearchRow.vala"
	g_critical ("Type `%s' does not implement abstract method `search_row_is_complete'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 33 "../src/Widgets/AbstractSearchRow.vala"
	return _tmp0_;
#line 193 "AbstractSearchRow.c"
}


gboolean
search_row_is_complete (SearchRow* self)
{
#line 33 "../src/Widgets/AbstractSearchRow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "../src/Widgets/AbstractSearchRow.vala"
	return SEARCH_ROW_GET_CLASS (self)->is_complete (self);
#line 204 "AbstractSearchRow.c"
}


SearchRow*
search_row_construct (GType object_type)
{
	SearchRow* self = NULL;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	self = (SearchRow*) g_type_create_instance (object_type);
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	return self;
#line 216 "AbstractSearchRow.c"
}


static void
value_search_row_init (GValue* value)
{
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	value->data[0].v_pointer = NULL;
#line 225 "AbstractSearchRow.c"
}


static void
value_search_row_free_value (GValue* value)
{
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	if (value->data[0].v_pointer) {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		search_row_unref (value->data[0].v_pointer);
#line 236 "AbstractSearchRow.c"
	}
}


static void
value_search_row_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	if (src_value->data[0].v_pointer) {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		dest_value->data[0].v_pointer = search_row_ref (src_value->data[0].v_pointer);
#line 249 "AbstractSearchRow.c"
	} else {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		dest_value->data[0].v_pointer = NULL;
#line 253 "AbstractSearchRow.c"
	}
}


static gpointer
value_search_row_peek_pointer (const GValue* value)
{
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	return value->data[0].v_pointer;
#line 263 "AbstractSearchRow.c"
}


static gchar*
value_search_row_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	if (collect_values[0].v_pointer) {
#line 275 "AbstractSearchRow.c"
		SearchRow * object;
		object = collect_values[0].v_pointer;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		if (object->parent_instance.g_class == NULL) {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 282 "AbstractSearchRow.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 286 "AbstractSearchRow.c"
		}
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		value->data[0].v_pointer = search_row_ref (object);
#line 290 "AbstractSearchRow.c"
	} else {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		value->data[0].v_pointer = NULL;
#line 294 "AbstractSearchRow.c"
	}
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	return NULL;
#line 298 "AbstractSearchRow.c"
}


static gchar*
value_search_row_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	SearchRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	if (!object_p) {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 314 "AbstractSearchRow.c"
	}
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	if (!value->data[0].v_pointer) {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		*object_p = NULL;
#line 320 "AbstractSearchRow.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		*object_p = value->data[0].v_pointer;
#line 324 "AbstractSearchRow.c"
	} else {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		*object_p = search_row_ref (value->data[0].v_pointer);
#line 328 "AbstractSearchRow.c"
	}
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	return NULL;
#line 332 "AbstractSearchRow.c"
}


GParamSpec*
param_spec_search_row (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	ParamSpecSearchRow* spec;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SEARCH_ROW), NULL);
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	return G_PARAM_SPEC (spec);
#line 352 "AbstractSearchRow.c"
}


gpointer
value_get_search_row (const GValue* value)
{
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SEARCH_ROW), NULL);
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	return value->data[0].v_pointer;
#line 363 "AbstractSearchRow.c"
}


void
value_set_search_row (GValue* value,
                      gpointer v_object)
{
	SearchRow * old;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SEARCH_ROW));
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	old = value->data[0].v_pointer;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	if (v_object) {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SEARCH_ROW));
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		value->data[0].v_pointer = v_object;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		search_row_ref (value->data[0].v_pointer);
#line 386 "AbstractSearchRow.c"
	} else {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		value->data[0].v_pointer = NULL;
#line 390 "AbstractSearchRow.c"
	}
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	if (old) {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		search_row_unref (old);
#line 396 "AbstractSearchRow.c"
	}
}


void
value_take_search_row (GValue* value,
                       gpointer v_object)
{
	SearchRow * old;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SEARCH_ROW));
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	old = value->data[0].v_pointer;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	if (v_object) {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SEARCH_ROW));
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		value->data[0].v_pointer = v_object;
#line 418 "AbstractSearchRow.c"
	} else {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		value->data[0].v_pointer = NULL;
#line 422 "AbstractSearchRow.c"
	}
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	if (old) {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		search_row_unref (old);
#line 428 "AbstractSearchRow.c"
	}
}


static void
search_row_class_init (SearchRowClass * klass)
{
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	search_row_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	((SearchRowClass *) klass)->finalize = search_row_finalize;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	((SearchRowClass *) klass)->get_widget = (GtkWidget* (*) (SearchRow *)) search_row_real_get_widget;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	((SearchRowClass *) klass)->get_search_condition = (SearchCondition* (*) (SearchRow *)) search_row_real_get_search_condition;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	((SearchRowClass *) klass)->populate = (void (*) (SearchRow *, SearchCondition*)) search_row_real_populate;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	((SearchRowClass *) klass)->is_complete = (gboolean (*) (SearchRow *)) search_row_real_is_complete;
#line 448 "AbstractSearchRow.c"
}


static void
search_row_instance_init (SearchRow * self)
{
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	self->ref_count = 1;
#line 457 "AbstractSearchRow.c"
}


static void
search_row_finalize (SearchRow * obj)
{
	SearchRow * self;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEARCH_ROW, SearchRow);
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	g_signal_handlers_destroy (self);
#line 469 "AbstractSearchRow.c"
}


GType
search_row_get_type (void)
{
	static volatile gsize search_row_type_id__volatile = 0;
	if (g_once_init_enter (&search_row_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_search_row_init, value_search_row_free_value, value_search_row_copy_value, value_search_row_peek_pointer, "p", value_search_row_collect_value, "p", value_search_row_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SearchRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchRow), 0, (GInstanceInitFunc) search_row_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType search_row_type_id;
		search_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SearchRow", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&search_row_type_id__volatile, search_row_type_id);
	}
	return search_row_type_id__volatile;
}


gpointer
search_row_ref (gpointer instance)
{
	SearchRow * self;
	self = instance;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	g_atomic_int_inc (&self->ref_count);
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	return instance;
#line 498 "AbstractSearchRow.c"
}


void
search_row_unref (gpointer instance)
{
	SearchRow * self;
	self = instance;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		SEARCH_ROW_GET_CLASS (self)->finalize (self);
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 513 "AbstractSearchRow.c"
	}
}



